VERSION 5.00
Object = "{DC8DEC8D-0714-4F8D-9D0F-DF49898C68C4}#1.0#0"; "GridPlusOCX.ocx"
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   Caption         =   "Form1"
   ClientHeight    =   6015
   ClientLeft      =   165
   ClientTop       =   510
   ClientWidth     =   10800
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   6015
   ScaleWidth      =   10800
   WindowState     =   2  'Maximized
   Begin GridPlusOCX.GridPlus GridPlus1 
      Height          =   4695
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   10695
      _ExtentX        =   18865
      _ExtentY        =   8281
      HeaderHeight    =   50
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      BeginProperty HeaderFont {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Timer Timer1 
      Left            =   4440
      Top             =   120
   End
   Begin VB.CheckBox Check1 
      BackColor       =   &H80000005&
      Caption         =   "Show Hot Row"
      Height          =   255
      Left            =   2400
      TabIndex        =   2
      Top             =   200
      Width           =   1455
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Ungrup"
      Height          =   375
      Left            =   1200
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Grup"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   975
   End
   Begin VB.Menu MyMenu 
      Caption         =   "MyMenu"
      Visible         =   0   'False
      Begin VB.Menu SubMenu 
         Caption         =   "Duty manager"
         Index           =   0
      End
      Begin VB.Menu SubMenu 
         Caption         =   "Supervisor"
         Index           =   1
      End
      Begin VB.Menu SubMenu 
         Caption         =   "Collaborator"
         Index           =   2
      End
      Begin VB.Menu SubMenu 
         Caption         =   "Director"
         Index           =   3
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim oRankFont As StdFont
Dim mRow As Long, mCol As Long
Dim mHotRow As Long
Dim CurRow As Long

Private Sub Check1_Click()
    If Check1.Value Then
        GridPlus1.RowsBackColorAlt = GridPlus1.RowsBackColor
        GridPlus1.AllowEdit = False
    Else
        GridPlus1.RowsBackColorAlt = vbButtonFace
        GridPlus1.AllowEdit = True
    End If
End Sub

Private Sub Command1_Click()
    With GridPlus1
        .Redraw = False
        .GroupByColumn 2, &H8CAD42, , , True
        .GroupByColumn 5, &HE7BD4A, 1, , True
        .ColWidth(0) = 80
        .Redraw = True
    End With
    Command1.Enabled = False
End Sub

Private Sub Command2_Click()
    GridPlus1.UnGroup
    Command1.Enabled = True
End Sub

Private Function GetRandomInfo(sName) As String
    Dim sRet As String
    Dim i As Long
    For i = 1 To RANDOM(3, 10)
        sRet = sRet & i & vbTab & _
            sName & vbTab & _
            Choose(i, "FXG", "EGR", "LRD", "UIY", "ERT", "SED", "NVD", "IEM", "SDF", "RTZ") & vbTab & _
            Format(RANDOM(10000, 99999), "$##,###.00") & vbTab & _
            DateAdd("d", i, Date) & vbCrLf
    Next
    GetRandomInfo = Left$(sRet, Len(sRet) - 2) 'remove the last vbCrLf
End Function

Private Sub GridPlus1_BeforeSorted()
    Dim Row As Long
    Dim mRedraw As Boolean
    With GridPlus1
        mRedraw = .Redraw
        .Redraw = False
        For Row = .RowsCount - 1 To 0 Step -1
            If .RowIsFullRow(Row) Then
                .CellImageIndex(Row - 1, 0) = 1
                .RowDelete Row
            End If
        Next
        .Redraw = mRedraw
    End With
End Sub

Private Sub GridPlus1_CustomSort(bAscending As Boolean, lSortColumn As Long, Value1 As Variant, Value2 As Variant, bSwap As Boolean)
    If bAscending Then
        bSwap = UBound(Split(Value1, ",")) < UBound(Split(Value2, ","))
    Else
        bSwap = UBound(Split(Value1, ",")) > UBound(Split(Value2, ","))
    End If
End Sub

Private Sub GridPlus1_HotCellChange(lRow As Long, lCol As Long)

    If Check1.Value = False Then Exit Sub
    If mHotRow <> lRow Then
        CurRow = lRow
        Timer1.Interval = 5
        '===========
        'Or use this, and remove the timer
        '===========
'        GridPlus1.Redraw = False
'        If mHotRow <> -1 Then
'            GridPlus1.RowBackColor(mHotRow) = -1
'            mHotRow = -1
'        End If
'        If lRow <> -1 Then
'            mHotRow = lRow
'            GridPlus1.RowBackColor(mHotRow) = &HFFE7E7
'        End If
'        GridPlus1.Redraw = True
    End If
End Sub

Private Sub Timer1_Timer()
    GridPlus1.Redraw = False
    If mHotRow <> -1 Then
        GridPlus1.RowBackColor(mHotRow) = -1
        mHotRow = -1
    End If
    If CurRow <> -1 Then
        mHotRow = CurRow
        GridPlus1.RowBackColor(mHotRow) = &HFFF3E5
    End If
    GridPlus1.Redraw = True
    Timer1.Interval = 0
End Sub

Private Sub GridPlus1_ImgMouseUp(ByVal lRow As Long, ByVal lCol As Long, Button As Integer, Shift As Integer)
    Dim R As Rect
    With GridPlus1
        If lCol = 0 Then
            
            If .CellImageIndex(lRow, lCol) = 1 Then
                .Redraw = False
                .CellImageIndex(lRow, lCol) = 2
                .InsertRow lRow + 2
                .RowIsFullRow(lRow + 1) = True
                
                .RowWordBreak(lRow + 1) = True
                .CellValue(lRow + 1, 0) = GetRandomInfo(.CellValue(lRow, 2))
                '.RowHeight(lRow + 1) = 64
                .AutoHeightRow (lRow + 1)
                .Redraw = True
            Else
                .CellImageIndex(lRow, lCol) = 1
                .RowDelete lRow + 1
            End If
        Else
            .GetCellRect lRow, lCol, VarPtr(R)
            mRow = lRow
            mCol = lCol
            PopupMenu MyMenu, vbPopupMenuRightAlign, GridPlus1.Left + (R.Right * Screen.TwipsPerPixelX), GridPlus1.Top + (R.Bottom) * Screen.TwipsPerPixelY, SubMenu(.CellTag(lRow, lCol))
        End If
    
    End With
End Sub

Private Sub SubMenu_Click(Index As Integer)
    With GridPlus1
        .CellValue(mRow, mCol) = SubMenu(Index).Caption
        .CellTag(mRow, mCol) = Index
    End With
End Sub


Private Sub Form_Load()
    Dim lRow As Long, lCol As Long, i As Long
    Dim Margin As Long
    Dim ColRankWidth As Long
    
    Set oRankFont = New StdFont
    oRankFont.Name = "Segoe MDL2 Assets"
    oRankFont.Size = 12 'RowsHeight/2
    Margin = 4
    
    mHotRow = -1
    
    InitGDIP
    With GridPlus1
        .Clear True 'Clear the ide config
        .Redraw = False     'cancel the grid drawing, this speeds up the whole process
        .ColsWidth = 120    'Default widht of all columns
        .RowsHeight = 32    'Default height of all ows
        '.FixedColums = 1   'freeze the first column
        .ColsCount = 10     'ten columns
        .RowsCount = 2000   'saying at the beginning the number of rows is faster than inserting rows
        .SelectionMode = GP_SelByMultiRow
        .SelectionColor = &HEF8C21
        .AllowColumnDrag = True
        .RowSelectorWidth = 0
        .ScrollBarStyle = sGoogle
        .RowsBackColorAlt = vbButtonFace
'====Column 0
        .ColAlign(0) = TopLeft
        .ColInitImgList 0, 24, 24, CenterCenter, True
        .ColImgListAddImage 0, App.Path & "\..\Vectores PNG\outline_add_black_24dp.png"
        .ColImgListAddImage 0, App.Path & "\..\Vectores PNG\outline_remove_black_24dp.png"
        .ColImagesEvents(0) = True
        .ColWidth(0) = 32
        .ColEditionLocked(0) = True
        .BorderRadius = 10
'====Column 1
        .ColumnText(1) = "Id"
        .ColAlign(1) = CenterRight
        .ColDataType(1) = GP_NUMERIC 'For sort as numeric
        .ColWidth(1) = 42
        .ColEditionLocked(1) = True
        
'====Column 2
        .ColumnText(2) = "Name"
        .ColAlign(2) = CenterLeft
        .ColDataType(2) = GP_STRING
        .ColFont(2).Bold = True
        .ColForeColor(2) = &HA55A00
        .ColEditionLocked(2) = True
        .ColInitImgList 2, 24, 24, CenterLeft, 5, False
        For i = 1 To 9
            .ColImgListAddImage 2, App.Path & "\..\Caras\" & i & ".jpg"
        Next

'====Column 3
        .ColumnText(3) = "Date"
        .ColAlign(3) = CenterLeft
        .ColDataType(3) = GP_DATE
        .ColFormat(3) = "DD MMMM"
        
'====Column 4
        .ColumnText(4) = "Active"
        .ColDataType(4) = GP_BOOLEAN
        .ColWidth(4) = 70
        
'====Column 5
        .ColumnText(5) = "Cargo"
        .ColAlign(5) = CenterLeft
        .ColDataType(5) = GP_STRING
        '.ColWidth(5) = 120
        .ColInitImgList 5, , , CenterRight, , True
        .ColImgListAddImage 5, App.Path & "\..\Vectores PNG\ArrowDown.png"
        .ColImagesEvents(5) = True
        .ColEditionLocked(5) = True
        
'====Column 6
        .ColumnText(6) = "Change"
        .ColAlign(6) = CenterRight
        .ColDataType(6) = GP_CURRENCY
        '.ColWidth(6) = 120
        .ColInitImgList 6, 16, 16, CenterRight, , True
        .ColImgListAddImage 6, App.Path & "\..\Vectores PNG\ArrowSolidDown.png"
        .ColImgListAddImage 6, App.Path & "\..\Vectores PNG\ArrowSolidUp.png"
        
'====Column 7
        .ColumnText(7) = "Statistics"
        .ColTextHidde(7) = True
        .ColEditionLocked(7) = True
        .ColDataType(7) = GP_CUSTOM
        
'====Column 8
        .ColumnText(8) = "Progress"
        .ColTextHidde(8) = True
        .ColDataType(8) = GP_NUMERIC
        
'====Column 9
        .ColumnText(9) = "Ranking"
        .ColTextHidde(9) = True
        .ColDataType(9) = GP_NUMERIC
         ColRankWidth = DrawRank(hdc, 0, 0, 0, 0, 0, 0, 0, oRankFont, &HE249, True)
        .ColWidth(9) = ColRankWidth / GridPlus1.GetWindowsDPI + Margin * 2
        .ColUserResizeLocked(9) = True
        .ColEditionLocked(9) = True
        
'====Fill cells with random data

        For lRow = 0 To GridPlus1.RowsCount - 1
            For lCol = 0 To GridPlus1.ColsCount - 1
                Dim Value  As Variant
                Dim ValRnd As Integer
                
                Select Case lCol
                    Case 0 'Only image +/-
                        .CellImageIndex(lRow, lCol) = 1
                        
                    Case 1 'ID
                        .CellValue(lRow, lCol) = lRow + 1
                        
                    Case 2 'Image and Text
                        ValRnd = RANDOM(1, 9)
                        .CellValue(lRow, lCol) = Choose(ValRnd, "Alicia", "Monica", "Julia", "Emilia", "Alberto", "Julio", "Jose", "Mariano", "Carlos")
                        .CellImageIndex(lRow, lCol) = ValRnd
                        
                    Case 3 'Date with format
                        .CellValue(lRow, lCol) = DateAdd("d", lRow, Date)
                        
                    Case 4 'CheckBox
                        .CellValue(lRow, lCol) = CBool(RANDOM(0, 1))
                        
                   Case 5: 'this cell can be changed with a menu (the menu is hidden in the form)
                        ValRnd = RANDOM(0, 3)
                        .CellValue(lRow, lCol) = SubMenu(ValRnd).Caption 'Rnd item of menu
                        .CellTag(lRow, lCol) = ValRnd 'save the index of the menu
                        .CellImageIndex(lRow, lCol) = 1 'Arrow down
                        
                    Case 6 'Text and image with Color and currency format, the negative number will be between parentecis()
                        Value = RANDOM(-5000, 5000)
                        If Value < 0 Then
                            .CellForeColor(lRow, lCol) = &H2121BD
                            .CellImageIndex(lRow, lCol) = 1
                        Else
                            .CellForeColor(lRow, lCol) = &H429439
                            .CellImageIndex(lRow, lCol) = 2
                        End If
                        .CellValue(lRow, lCol) = Value
                        
                    Case 7 'Custom draw cell with a linear graph
                        Value = vbNullString
                        For i = 0 To RANDOM(3, 10)
                            Value = Value & RANDOM(1, 100) & ","
                        Next
                        .CellValue(lRow, lCol) = Left$(Value, Len(Value) - 1)
                        
                    Case 8 'Custom draw cell with a Progressbar
                        .CellValue(lRow, lCol) = RANDOM(0, 100)
                        
                    Case 9 'Custom draw cell with charater of start
                        .CellValue(lRow, lCol) = RANDOM(0, 5)
              
                   
                End Select
      
            Next
        Next
        .Redraw = True 'enable drawing
    End With

End Sub

Private Function RANDOM(ByVal Min As Single, ByVal Max As Single) As Single
    RANDOM = Int((Max - Min + 1) * Rnd + Min)
End Function

Private Sub Form_Resize()
    On Error Resume Next
    If Me.WindowState = vbMinimized Then Exit Sub
    GridPlus1.Move 200, 600, Me.ScaleWidth - 400, Me.ScaleHeight - 800
End Sub

Private Sub Form_Terminate()
    TerminateGDIP
End Sub

Private Sub GridPlus1_CellPostPaint(ByVal hdc As Long, ByVal Row As Long, ByVal Col As Long, ByVal Left As Long, ByVal Top As Long, ByVal Right As Long, ByVal Bottom As Long)
    Dim Arr
    Dim Margin As Long
    
    If Len(GridPlus1.CellValue(Row, Col)) = 0 Then Exit Sub
    If GridPlus1.ColRef(Col) = 7 Then
        
        Arr = Split(GridPlus1.CellValue(Row, Col), ",")
        Margin = 2 * GridPlus1.GetWindowsDPI
        DrawLineChart hdc, Arr, Left + Margin, Top + Margin, Right - Left - Margin * 2, Bottom - Top - Margin * 2, vbRed, vbBlue, Margin
    End If
    
    If GridPlus1.ColRef(Col) = 8 Then
        Margin = 4 * GridPlus1.GetWindowsDPI
        DrawProgress hdc, Val(GridPlus1.CellValue(Row, Col)), Left + Margin, Top + Margin * 2, Right - Left - Margin * 2, Bottom - Top - Margin * 4, &H8000000A, &HFFA55A, vbWhite, 1 * GridPlus1.GetWindowsDPI, 15 * GridPlus1.GetWindowsDPI
    End If
    
    If GridPlus1.ColRef(Col) = 9 Then
        Margin = 4 * GridPlus1.GetWindowsDPI
        'Draw Star
        DrawRank hdc, GridPlus1.CellValue(Row, Col), Left + Margin, Top + Margin, Right - Margin, Bottom - Margin, vb3DLight, &H31C6FF, oRankFont, &HE249, False
        'Draw Heart
        'DrawRank hdc, GridPlus1.CellValue(Row, Col), Left + Margin, Top + Margin, Right - Margin, Bottom - Margin, vbButtonFace, vbRed, oRankFont, &HE0A5, False
    End If
End Sub


Private Sub GridPlus1_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyDelete Then
        With GridPlus1
            If .CurCol = 9 Then
                If .CurRow <> -1 Then
                    .CellValue(.CurRow, .CurCol) = 0
                End If
            End If
        End With
    End If
End Sub


Private Sub GridPlus1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim Margin As Long
    Dim Row As Long, Col As Long
    Dim R As Rect, Width As Long
    Dim NewValue As Long, DC As Long
    Static LastRow As Long, LastCol As Long
    
    If GridPlus1.GetHotCell(X, Y, Row, Col, VarPtr(R)) = False Then Exit Sub
    
    If GridPlus1.RowIsFullRow(Row) Then Exit Sub
    
    If GridPlus1.ColRef(Col) = 9 And Row > -1 Then
        If LastRow <> Row Or LastCol <> Col Then
            LastRow = Row
            LastCol = Col
            GridPlus1.Refresh
        End If
    
         X = X - R.Left
         Width = R.Right - R.Left
         NewValue = X \ (Width / 5) + 1
         If Button = vbLeftButton Then
            GridPlus1.CellValue(Row, Col) = NewValue
         Else
            DC = GetDC(GridPlus1.hwnd)
            Margin = 4 * GridPlus1.GetWindowsDPI
            
            'draw Star
            DrawRank DC, NewValue, R.Left + Margin, R.Top + Margin, R.Right - Margin, R.Bottom - Margin, vb3DLight, &H31C6FF, oRankFont, &HE249, False
            'Draw Heart
            'DrawRank hdc, GridPlus1.CellValue(Row, Col), Left + Margin, Top + Margin, Right - Margin, Bottom - Margin, vbButtonFace, vbRed, oRankFont, &HE0A5, False

            
            ReleaseDC GridPlus1.hwnd, DC
         End If
    Else
        If LastRow <> -1 And LastCol <> -1 Then
            LastRow = -1
            LastCol = -1
            GridPlus1.Refresh
        End If
    End If
End Sub

Private Sub GridPlus1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    GridPlus1_MouseMove Button, Shift, X, Y
End Sub

Private Sub GridPlus1_OnColumnDrag(ByVal SrcCol As Long, ByVal DestCol As Long, Cancel As Boolean)
    If DestCol = 0 Then Cancel = True
End Sub

Private Sub GridPlus1_BeforeColumnDrag(ByVal lCol As Long, Cancel As Boolean)
    If lCol = 0 Then Cancel = True
End Sub
