VERSION 5.00
Object = "{DC8DEC8D-0714-4F8D-9D0F-DF49898C68C4}#1.0#0"; "GridPlusOCX.ocx"
Begin VB.Form Form1 
   BackColor       =   &H00FFFFFF&
   Caption         =   "Form1"
   ClientHeight    =   5160
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   11190
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5160
   ScaleWidth      =   11190
   StartUpPosition =   3  'Windows Default
   Begin GridPlusOCX.GridPlus GridPlus1 
      Height          =   3615
      Left            =   240
      TabIndex        =   2
      Top             =   840
      Width           =   10935
      _ExtentX        =   19288
      _ExtentY        =   6376
      HeaderHeight    =   50
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      BeginProperty HeaderFont {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.CommandButton CmdAddNew 
      Caption         =   "Add"
      Height          =   495
      Left            =   7200
      TabIndex        =   1
      Top             =   120
      Width           =   1575
   End
   Begin VB.CommandButton CmdDelete 
      Caption         =   "Delete"
      Height          =   495
      Left            =   8880
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Cnn As Object ' ADODB.Connection

Private Sub Form_Load()
    Dim Row As Long, Col As Long
    Dim rs As ADODB.Recordset
    
    On Error GoTo ErrorHandler
    
    Set m_Cnn = CreateObject("ADODB.Connection") ' The same as New ADODB.Connection - we use late binding to use any installed version of ADO
    m_Cnn.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & App.Path & "\..\Data\Test.mdb"
    
    Set rs = New ADODB.Recordset
    'Set rs = CreateObject("ADODB.Recordset")
    
    'rs.Open "SELECT [ID],[Company],[First Name],[Last Name],[E-mail] FROM Customers", m_Cnn, adOpenStatic
    rs.Open "Select * from Customers", m_Cnn, adOpenStatic
    
    With GridPlus1
        .FillFromRS rs
        '.ColWidth(0) = 50
        .RowsCount = .RowsCount + 1
        .Sort 0, lgSTAscending
    End With
    
    Exit Sub
ErrorHandler:
   If Err.Number = 429 Then
      MsgBox "Could not initialize MS ActiveX Data Objects Library (MS ADO)", vbCritical, "Error: " & Err.Number
   Else
      MsgBox Err.Description, vbCritical, "Error: " & Err.Number
   End If
End Sub

Private Sub CmdAddNew_Click()
    AddRow True
End Sub

Private Sub CmdDelete_Click()
   Dim lCurRow As Long
   
   lCurRow = GridPlus1.CurRow
   
   If lCurRow = -1 Then
      MsgBox "Select a row to delete!", vbCritical
      Exit Sub
   End If
   
   If MsgBox("Do you really want to delete the current row?", vbQuestion + vbYesNo) = vbYes Then
      On Error GoTo DeleteError
      ' Remove the record from the database and from the grid
      m_Cnn.Execute "DELETE FROM Customers WHERE ID=" & GridPlus1.CellValue(lCurRow, 0)
      GridPlus1.RowDelete lCurRow

      ' Highlight the appropriate row
      If lCurRow = GridPlus1.RowsCount - 1 And GridPlus1.RowsCount > 1 Then
         lCurRow = lCurRow - 1
      End If

      GridPlus1.SetCurCell lCurRow, GridPlus1.CurCol
      GridPlus1.SetFocus
   End If
   
   
   Exit Sub
   
DeleteError:
    MsgBox Err.Description, vbCritical
End Sub


Private Sub Form_Unload(Cancel As Integer)
    m_Cnn.Close
End Sub

Private Sub Form_Resize()
    GridPlus1.Move 200, 700, Me.ScaleWidth - 400, Me.ScaleHeight - 900
End Sub

Private Sub GridPlus1_AfterEdit(ByVal lRow As Long, ByVal lCol As Long, ByVal vOldValue As Variant)
    Dim sSQL As String
    Dim vNewVal As Variant
    Dim sNewVal As String
      
    vNewVal = GridPlus1.CellValue(lRow, lCol)
    
    If vNewVal = vOldValue Then Exit Sub

    Select Case VarType(vNewVal)
        Case vbString
           sNewVal = "'" & Replace$(vNewVal, "'", "''") & "'"
        Case vbSingle, vbDouble, vbCurrency, vbDecimal
           sNewVal = Str(vNewVal)
        Case vbNull, vbEmpty
           sNewVal = "NULL"
        Case vbBoolean
           sNewVal = IIf(vNewVal, 1, 0)
        Case Else
           sNewVal = CStr(vNewVal)
    End Select
    
    sSQL = "UPDATE [Customers] SET [" & GridPlus1.ColumnText(lCol) & "]=" & sNewVal & _
            " WHERE [Id]=" & GridPlus1.CellValue(lRow, 0) '<--id

   On Error GoTo UpdateError
   m_Cnn.Execute sSQL
   
   If lRow = GridPlus1.RowsCount - 1 Then
        AddRow False
   End If
   
   Exit Sub
   
UpdateError:
    MsgBox Err.Description, vbCritical
    GridPlus1.CellValue(lRow, lCol) = vOldValue
    
End Sub
    
Private Sub GridPlus1_AfterSorted()
    With GridPlus1
        .RowsCount = .RowsCount + 1
        .RowIsFullRow(.RowsCount - 1) = True
        .CellAlign(.RowsCount - 1, 0) = CenterLeft
        .CellValue(.RowsCount - 1, 0) = "Add New"
    End With
End Sub

Private Sub GridPlus1_BeforeSorted()
    GridPlus1.RowDelete GridPlus1.RowsCount - 1
End Sub

Private Sub GridPlus1_CurCellChange(ByVal lNewRowIfAny As Long, ByVal lNewColIfAny As Long, ByVal lOldRowIfAny As Long, ByVal lOldColIfAny As Long)
    If lNewRowIfAny = GridPlus1.RowsCount - 1 Then
        AddRow True
    End If
End Sub

Private Sub AddRow(ByVal bActivateRow As Boolean)
   With GridPlus1
      .Redraw = False
      
      ' Create a new record in the grid
      '.RowsCount = .RowsCount + 1
      .InsertRow .RowsCount
      ' Create a new record in the database
      Dim rs As Object
      Set rs = m_Cnn.Execute("SELECT MAX(ID) FROM Customers")
      ' The first field in the result recordset contains the last ID.
      ' If the ID field were auto-increment, you would use the
      ' "SELECT @@IDENTITY" query instead - it returns the value of
      ' the auto-increment field that is generated on your connection.
      ' It works in Jet 4.0 OLE DB Provider with MS Access 2000 or higher
      ' and for MS SQL Server too.
      Dim lNewID As Long
      lNewID = rs(0) + 1
      .CellValue(.RowsCount - 2, 0) = lNewID
      m_Cnn.Execute "INSERT INTO Customers (ID) VALUES (" & lNewID & ")"
      
      If bActivateRow Then
         .SetCurCell .RowsCount - 2, 1, True
      End If
      
      .Redraw = True
   End With
End Sub



